exports.NumericMap = {
    create: createMap
};
function createMap() {
    var lookup = {};
    return {
        containsKey: function (key) {
            return lookup.hasOwnProperty(key.toString());
        },
        entries: function () {
            return Object.keys(lookup).map(function (key) {
                return {
                    key: Number(key),
                    value: lookup[key]
                };
            });
        },
        values: function () {
            return Object.keys(lookup).map(function (key) { return lookup[key]; });
        },
        get: function (key) {
            return lookup[key];
        },
        set: function (key, value) {
            lookup[key] = value;
        }
    };
}
