var stringifier_1 = require("../expressions/stringifier");
var estreeFactory_1 = require("../../estreeFactory");
function parseVariableDeclaration(declaration, currentNode, context) {
    for (var _i = 0, _a = declaration.declarations; _i < _a.length; _i++) {
        var declarator = _a[_i];
        var declarationExpression = declarator.init
            ? createAssignmentExpressionFrom(declarator)
            : declarator.id;
        currentNode = context.createNode()
            .appendTo(currentNode, stringifier_1.stringify(declarationExpression), declarator);
    }
    return { normal: currentNode };
}
exports.parseVariableDeclaration = parseVariableDeclaration;
function createAssignmentExpressionFrom(declarator) {
    return estreeFactory_1.createAssignmentExpression({
        left: declarator.id,
        right: declarator.init
    });
}
