var stringifier_1 = require("../expressions/stringifier");
var ESTree = require("../../estree");
function parseExpressionStatement(expressionStatement, currentNode, context) {
    return {
        normal: parseExpression(expressionStatement.expression, currentNode, context)
    };
}
exports.parseExpressionStatement = parseExpressionStatement;
function parseExpression(expression, currentNode, context) {
    if (expression.type === ESTree.NodeType.SequenceExpression) {
        return parseSequenceExpression(expression, currentNode, context);
    }
    return context.createNode()
        .appendTo(currentNode, stringifier_1.stringify(expression), expression);
}
exports.parseExpression = parseExpression;
function parseSequenceExpression(sequenceExpression, currentNode, context) {
    for (var _i = 0, _a = sequenceExpression.expressions; _i < _a.length; _i++) {
        var expression = _a[_i];
        currentNode = parseExpression(expression, currentNode, context);
    }
    return currentNode;
}
